**neetoCodeBlocks** is the library that provides code editor components.

## Installation

```bash
yarn add @bigbinary/neeto-code-blocks
```

Install all the peer dependencies using the below command:

```bash
yarn add @bigbinary/neeto-commons-frontend @bigbinary/neeto-icons @bigbinary/neetoui @codesandbox/sandpack-react @monaco-editor/react antd@4.18.7 axios@0.27.2 formik@2.2.9 ramda@0.28.0 react@17.0.2 react-dom@17.0.2 react-router-dom@5.2.0 react-toastify@8.0.2 yup@0.32.11 zustand@4.3.2
```

## Development

Install all the dependencies by executing following command.

```bash
yarn install
```

Running the `yarn start` command starts an example application. Use this
application to test out changes.

# Building and releasing.

The `@bigbinary/neeto-code-blocks` package gets published to NPM when we
merge a PR with `patch`, `minor` or `major` label to the `main` branch. The
`patch` label is used for bug fixes, `minor` label is used for new features and
`major` label is used for breaking changes. You can checkout the
`Create and publish releases` workflow in GitHub Actions to get a live update.

In case if you missed to add the label, you can manually publish the package.
For that first you need to create a PR to update the version number in the
`package.json` file and merge it to the `main` branch. After merging the PR, you
need to create a
[new github release](https://github.com/bigbinary/neeto-code-blocks/releases/new)
from main branch. Whenever a new release is created with a new version number,
the github actions will automatically publish the built package to npm. You can
checkout the `Publish to npm` workflow in GitHub Actions to get a live update.

Please note that before publishing the package, you need to verify the
functionality in some of the neeto web-apps locally using `yalc` package
manager. The usage of yalc is explained in this video:
https://youtu.be/QBiYGP0Rhe0
